;  KTi away add-on - Dr. Crazy
;  misc away script
;  Released .... Never
;  Away System Aliases
;
alias away {
  ;  if ($version < 5.51 || $version == $null) { echo 4 -a ERROR: You must use either mIRC v5.51 or above inorder to use this addon! | halt }
  if ($exists($mircdirawaysys) == $false) { mkdir $mircdirawaysys }
  if ($1 == $null) {
    if ($away == $false) { away.help }
    else { away }
  }
  elseif ($1 == -?) { away.help }
  elseif ($1 == -t) {
    if ($2 == $null) { echo 2 -a Action Duration is currently set to $away.duration second(s) }
    else {
      writeini $mircdiraway.cfg Settings ActionDuration $strip($2)
      if ($away == $true && $chan(0) >= 1) { .timeraway 0 $away.duration amsg Away[ %away.reason / %away.settings $away.pager ] }
      echo 2 -a Action Duration has been set to $strip($2) second(s)
    }
  }
  elseif ($1 == -w) {
    if ($2 == $null) {
      if ($away.pagewav == $null) { echo 2 -a No wav is currently set.. using multiple beeps instead }
      else { echo 2 -a $away.pagewav is currently being used }
    }
    else {
      if ($right($strip($2),3) != wav) { echo 4 -a ERROR: The filename must end with the .WAV ext. | halt }
      if ($nopath($strip($2)) == $null) { echo 4 -a ERROR: Unable to find Wav File... | halt }
      if ($nopath($strip($2)) == $strip($2)) { set %away.wavtmp $mircdir $+ $strip($2) }
      else { set %away.wavtmp $strip($2) }
      if ($exists($strip($2)) == $false) {
        set %away.wavtmp $wavedir $+ $strip($2)      
        if ($exists(%away.wavtmp) == $false) { echo 4 -a ERROR: Unable to find Wav File... | halt }
      }
      writeini $mircdiraway.cfg Settings PagerWav %away.wavtmp
      echo 2 -a Pager Wav has been set to use %away.wavtmp
    }
  }
  elseif ($1 == -log) {
    if ($exists($mircdirawaysys\away.log) == $false) { echo 4 -a ERROR: $mircdirawaysys\away.log does not exist... }
    else { away.log.check }
  }
  elseif ($1 == -erase) {
    if ($exists($mircdirawaysys\away.log) == $false) { echo 4 -a ERROR: $mircdirawaysys\away.log does not exist... }
    else {
      .remove $mircdirawaysys\away.log 
      echo 2 -a Erased $mircdirawaysys\away.log 
    }
  }
  elseif ($1 == -about) {
    window -c @AboutAwaySystem
    window -l @AboutAwaySystem 0 0 640 215 courier new
    aline 6 @AboutAwaySystem KTi Away v1.0
    aline 6 @AboutAwaySystem -
    aline 6 @AboutAwaySystem bleh.
    aline 2 @AboutAwaySystem 
    aline 5 @AboutAwaySystem 
    aline 5 @AboutAwaySystem 
    aline 5 @AboutAwaySystem 
    aline 5 @AboutAwaySystem 
    aline 5 @AboutAwaySystem 
    aline 5 @AboutAwaySystem 
    aline 6 @AboutAwaySystem -
  }
  elseif ($1 == -) {
    if ($2 == $null) { away.help | halt }
    if ($server == $null) { echo 4 -a ERROR: You are not connected to an IRC Server... | halt }
    set %away.logging off
    set %away.pager off
    set %away.settings l/p:off
    set %away.reason $2-
    .away $2- / [l/p:off]
  }
  elseif ($1 == -l) {
    if ($2 == $null) { away.help | halt }
    if ($server == $null) { echo 4 -a ERROR: You are not connected to an IRC Server... | halt }
    set %away.logging on
    set %away.pager off
    set %away.settings l:on
    set %away.reason $2-
    .away $2- [l:on]
  }
  elseif ($1 == -p) {
    if ($2 == $null) { away.help | halt }
    if ($server == $null) { echo 4 -a ERROR: You are not connected to an IRC Server... | halt }
    set %away.logging off
    set %away.pager on
    set %away.settings p:on
    set %away.reason $2-
    .away $2- [p:on]
  }
  elseif ($1 == -lp || $1 == -pl) {
    if ($2 == $null) { away.help | halt }
    if ($server == $null) { echo 4 -a ERROR: You are not connected to an IRC Server... | halt }
    set %away.logging on
    set %away.pager on
    set %away.settings l/p:on
    set %away.reason $2-
    .away $2- [l/p:on]
  }
  else {
    if ($server == $null) { echo 4 -a ERROR: You are not connected to an IRC Server... | halt }
    set %away.logging off
    set %away.pager on
    set %away.settings p:on
    set %away.reason $1-
    .away $1- [p:on]
  }
}
alias away.help {
  window -c @AwaySystemHelp
  window -l @AwaySystemHelp 0 0 640 280 courier new
  aline 4 @AwaySystemHelp ### KTi Away v1.0 Usage Help ###
  aline 2 @AwaySystemHelp -
  aline 5 @AwaySystemHelp /away <reason>                           <- marks you as being away with msg logging off / pager on.
  aline 5 @AwaySystemHelp /away - <reason>                         <- marks you as being away msg logging off / pager off. 
  aline 5 @AwaySystemHelp /away -l <reason>                         <- marks you as being away msg logging on / pager off. 
  aline 5 @AwaySystemHelp /away -lp <reason>                       <- marks you as being away msg logging on / pager on. 
  aline 5 @AwaySystemHelp /away                                           <- unmarks you as being away.
  aline 5 @AwaySystemHelp /away -t                                        <- displays the duration for the 'is away' action in seconds.
  aline 5 @AwaySystemHelp /away -t <seconds>                      <- sets the duration for the 'is away' action.
  aline 5 @AwaySystemHelp /away -w                                       <- displays the dirpath/filename.wav being used as the pager wav.
  aline 5 @AwaySystemHelp /away -w <dirpath/filename.wav> <- sets the .WAV to be used when paged.
  aline 5 @AwaySystemHelp /away -log                                     <- displays the Away System Log.
  aline 5 @AwaySystemHelp /away -erase                                 <- erases the Away System Log
  aline 5 @AwaySystemHelp /away -about                                 <- displays information about KTi Away v1.0
  aline 5 @AwaySystemHelp /away -?                                        <- displays the same information you are currently viewing.
}
alias away.log.check {
  if ($exists($mircdirawaysys\away.log) == $false) { goto end }
  window -c @AwaySystemLog
  window @AwaySystemLog 0 0 640 192 courier new
  set %away.v 0
  :begin
  inc %away.v 1
  set %away.tmp $read -nl $+ %away.v $mircdirawaysys\away.log
  if (%away.tmp == $null) { goto end }
  if ($gettok(%away.tmp,1,32) == away) {
    echo 12 @AwaySystemLog ### away - $gettok(%away.tmp,2-4,32) -
    echo 5 @AwaySystemLog  $gettok(%away.tmp,5-90000,32)
  }
  if ($gettok(%away.tmp,1,32) == back) {
    echo 12 @AwaySystemLog ### back - $gettok(%away.tmp,2-4,32) -
  }
  if ($gettok(%away.tmp,1,32) == page) {
    echo 2 @AwaySystemLog ### recieved page from $gettok(%away.tmp,2,32) - $gettok(%away.tmp,3-5,32) -
    echo 5 @AwaySystemLog  $gettok(%away.tmp,6-90000,32)
  }
  if ($gettok(%away.tmp,1,32) == msg) {
    echo 2 @AwaySystemLog ### recieved msg from $gettok(%away.tmp,2,32) - $gettok(%away.tmp,3-5,32) -
    echo 5 @AwaySystemLog  $gettok(%away.tmp,6-90000,32)
  }
  if ($gettok(%away.tmp,1,32) == chat) {
    echo 2 @AwaySystemLog ### recieved DCC chat request from $gettok(%away.tmp,2,32) - $gettok(%away.tmp,3-5,32) -
  }
  if ($gettok(%away.tmp,1,32) == send) {
    echo 2 @AwaySystemLog ### recieved DCC send request from $gettok(%away.tmp,2,32) - $gettok(%away.tmp,3-5,32) -
    echo 5 @AwaySystemLog  $gettok(%away.tmp,2,32) tried to send you $gettok(%away.tmp,6,32)
  }
  goto begin
  :end
  if (%away.v == 1) { echo 2 -a the log file is empty... }
}
;
;  Away System Custom Identifiers
;
alias away.rtime {
  set %away.realtime $time
  set %away.hour $token(1,58,%away.realtime)
  set %away.type am  
  if (%away.hour = 0) set %away.hour 12 
  if (%away.hour > 12) { set %away.hour %away.hour - 12 | set %away.type pm }
  if (%away.hour = 12) set %away.type pm
  set %away.min $token(2,58,%away.realtime)
  set %away.realtime %away.hour $+ : $+ %away.min %away.type
  unset %away.hour | unset %away.min | unset %away.type | return %away.realtime
}
alias away.duration {
  if ($exists($mircdiraway.cfg) == $false || $readini -n $mircdiraway.cfg Settings ActionDuration == $null) { return 1800 }
  else { return $readini -n $mircdiraway.cfg Settings ActionDuration }
}
alias away.pagewav {
  if ($exists($mircdiraway.cfg) == $false || $readini -n $mircdiraway.cfg Settings PagerWav == $null) { return }
  else { return $readini -n $mircdiraway.cfg Settings PagerWav }
}
alias away.pager {
  if (%away.pager == on) { return / /ctcp $me page <reason> }
  else { return }
}
alias away.logged {
  if (%away.logging == on) { return [ msg logged ] }
  else { return }
}
;
;  Away System Events
;
on 1:join:#: {
  if ($nick == $me && $chan(0) == 1 && $away == $true) {  .timeraway 0 $away.duration ame Away[ %away.reason / %away.settings $away.pager ] }
}
on 1:part:#: {
  if ($nick == $me && $chan(0) == 1 && $away == $true) { .timeraway off }
}
ctcp 1:*page*: {
  if ($nick != $me && $away == $true) {
    if (%away.pager == on) {
      if ($2 == $null) { .notice $nick usage: /ctcp $me page <reason> }
      else {
        .notice $nick [ paging $me / $time ] 
        echo 2 -s $nick paged you! reason logged
        echo 2 -s Type '/away -log' to view log file...
        write $mircdirawaysys\away.log page $nick $adate $away.rtime $2-
        if ($away.pagewav == $null) { beep 0 }
        else {
          if ($exists($away.pagewav) == $false) { beep 0 }
          else { splay $away.pagewav }
        }
        flash -b away pager alarm
      }
    }
    else { .notice $nick [ pager:off / $time ] }
    halt
  }
}
on 1:text:*:?: {
  if ($nick != $me && $away == $true) {
    .describe $nick Away[ %away.reason / %away.settings / $away.pager / $away.logged ]
    if (%away.logging == on) {
      echo -s [ $nick msged you! / msg logged ]
      echo -s [ Type '/away -log' to view log file... ]
      write $mircdirawaysys\away.log msg $nick $adate $away.rtime $1-
      .timer 1 1 close -m $nick
    }
  }
}
on 1:input:*: {
  set %away.input /raw away
  set %away.input2 /quote away
  set %away.input3 /.raw away
  set %away.input4 /.quote away
  if ($gettok($1-,1-2,32) == %away.input) { echo 4 -a ERROR: Use /away instead... | halt }
  elseif ($gettok($1-,1-2,32) == %away.input2) { echo 4 -a ERROR: Use /away instead... | halt }
  elseif ($gettok($1-,1-2,32) == %away.input3) { echo 4 -a ERROR: Use /away instead... | halt }
  elseif ($gettok($1-,1-2,32) == %away.input4) { echo 4 -a ERROR: Use /away instead... | halt }
}
raw 305:*: {
  ;  echo 2 -a you are back from being away
  write $mircdirawaysys\away.log back $adate $away.rtime
  if ($chan(0) >= 1) {
    amsg Back[ %away.reason / $time / $duration($calc($ctime - %away.ctime)) ]
  }
  .timeraway off
  unset %away.*
  away.log.check
  halt
}
raw 306:*: {
  haltdef
  ;  echo -a [ you are now away with msg logging %away.logging and pager %away.pager ]
  if ($chan(0) >= 1) {
    amsg  Away[ %away.reason / %away.settings $away.pager ]
    .timeraway 0 $away.duration ame Away[ %away.reason / %away.settings $away.pager ]
  }
  set %away.ctime $ctime
  write $mircdirawaysys\away.log away $adate $away.rtime %away.reason
  halt
}
on 1:connect: {
  if ($exists($mircdirawaysys\away.log) == $true && $read -nl1 $mircdirawaysys\away.log != $null) {
    echo -s [ Away system log is not empty ]
    echo -s [ type '/away -log' to view log file... ]
  }
  unset %away.*
}
;ctcp 1:dcc: {
;  if ($nick != $me && $away == $true) {
;    if ($2 == chat) {
;      write $mircdirawaysys\away.log chat $nick $adate $away.rtime
;      echo -s [ ignored DCC chat request from $nick 5logged ]
;      echo -s [ type '/away -log' to view log file... ]
;      .notice $nick ignoring DCC chat request [i'm away]
;    }
;    if ($2 == send) {
;      write $mircdirawaysys\away.log send $nick $adate $away.rtime $3
;      echo -s [ignored DCC send request from $nick 5logged ]
;      echo -s [ Type '/away -log' to view log file... ]
;      .notice $nick ignoring DCC send request [i'm away]
;    }
;    halt
;  }
;}
menu channel {
  KTi away
  .msg log off/page on:/away $$?="Enter reason"
  .msg log on/page off:/away - $$?="Enter reason"
  .msg/page off:/away - $$?="Enter reason"
  .msg/page on:/away -lp $$?="Enter reason"
  .back:/away
  .show away popuptime:/away -t
  .set away popuptime:/away -t $$?="Set Away Pop-up time (seconds)"
  .show away log:/away -log
  .erase away log:/away -erase
  .about away:/away -about
  .about help:/away -?
}
